/**
	FND display utility
	
	v1.0

	@author	tchan90@daum.net
*/
#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include "putil.h"

#include "Fnd.h"

// DIGIT ɵ, low active
#define	PORT_FND0	PORT(B,0)		
#define	PORT_FND1	PORT(B,1)
#define	PORT_FND2	PORT(B,2)
#define	PORT_FND3	PORT(B,3)

// A-G ɵ, low active
#define	PORT_DATA0	PORT(D,0)
#define	PORT_DATA1	PORT(D,1)
#define	PORT_DATA2	PORT(D,2)
#define	PORT_DATA3	PORT(D,3)
#define	PORT_DATA4	PORT(D,4)
#define	PORT_DATA5	PORT(D,5)
#define	PORT_DATA6	PORT(D,6)
#define	PORT_DATA7	PORT(D,7)



void fnd_init()
{
	PORT_DIR_OUT(PORT_FND0);
	PORT_DIR_OUT(PORT_FND1);
	PORT_DIR_OUT(PORT_FND2);
	PORT_DIR_OUT(PORT_FND3);


	PORT_DIR_OUT(PORT_DATA0);
	PORT_DIR_OUT(PORT_DATA1);
	PORT_DIR_OUT(PORT_DATA2);
	PORT_DIR_OUT(PORT_DATA3);
	PORT_DIR_OUT(PORT_DATA4);
	PORT_DIR_OUT(PORT_DATA5);
	PORT_DIR_OUT(PORT_DATA6);
	PORT_DIR_OUT(PORT_DATA7);
}

char _fnd_data[4] = {0, 0, 0, 0};


/**
	const char digit[] = 
	{0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x83, 0xD8, 0x80, 0x98, 0x86};
	//0	 	1	  2     3     4     5     6     7     8     9	  E	
*/
static char fnd_data(char value)
{
	char fndData;
	switch (value)
	{
		case 0:	fndData = 0xC0; break;
		case 1: fndData = 0xF9; break;
		case 2: fndData = 0xA4; break;
		case 3: fndData = 0xB0; break;
		case 4: fndData = 0x99; break;
		case 5: fndData = 0x92; break;
		case 6: fndData = 0x83; break;
		case 7: fndData = 0xD8; break;
		case 8: fndData = 0x80; break;
		case 9: fndData = 0x98; break;
		case ' ': fndData = 0xFF; break;			// all off.
		case 'E': fndData = 0x86; break;
		case '-': fndData = 0xBF; break;
		default:
			fndData = 0x86; break;
			//return;
	}
	return fndData;
}

/**
	FND ǥ  .

	index : 0..3
*/
void fnd_put(int index, char value)
{
	if ((index < 0) || (index > 3)) return;

	_fnd_data[index] = fnd_data(value);
}

/**
	FND ǥ  .

	index : 0..3
*/
void fnd_put_withdp(int index, char value, int dpEnable)
{
	if ((index < 0) || (index > 3)) return;

	
	_fnd_data[index] = fnd_data(value);

	// enable DP.
	if (dpEnable) _fnd_data[index] &= 0x7F;
}

/**
	DP('.') ߰ ǥ.
	ݵ   Ŀ ߰ؾ.

	,	"E."  ǥõ.

		fnd_put(1, 'E'); 
		fnd_dpEnable(1);	// ̿  dpEnable() ߿ ؾ.
		
	Ʒ  ϸ,
		fnd_dpEnable(1);
		fnd_put(1, 'E');	// 'E'  ǥõ.
*/
void fnd_dpEnable(int index)
{
	if ((index < 0) || (index > 3)) return;

	// DP == PORTA7. Ŭ.
	_fnd_data[index] &= 0x7F;
}

/**
	FND   ƾ.
	- ӵ  ؼ... fnd_put ̹ ͸ ؼ _fnd_data[] .
	DIG(x) PIN low - write select
*/
static void fnd_out(unsigned char di, char fndData)
{
	asm("cli");

	IS_BIT_SET(fndData, 0)? PORT_CLR(PORT_DATA0) : PORT_SET(PORT_DATA0);
	IS_BIT_SET(fndData, 1)? PORT_CLR(PORT_DATA1) : PORT_SET(PORT_DATA1);
	IS_BIT_SET(fndData, 2)? PORT_CLR(PORT_DATA2) : PORT_SET(PORT_DATA2);
	IS_BIT_SET(fndData, 3)? PORT_CLR(PORT_DATA3) : PORT_SET(PORT_DATA3);
	IS_BIT_SET(fndData, 4)? PORT_CLR(PORT_DATA4) : PORT_SET(PORT_DATA4);
	IS_BIT_SET(fndData, 5)? PORT_CLR(PORT_DATA5) : PORT_SET(PORT_DATA5);
	IS_BIT_SET(fndData, 6)? PORT_CLR(PORT_DATA6) : PORT_SET(PORT_DATA6);
	IS_BIT_SET(fndData, 7)? PORT_CLR(PORT_DATA7) : PORT_SET(PORT_DATA7);

	// disable all fnds except current one.
	PORT_SET(PORT_FND0);
	PORT_SET(PORT_FND1);
	PORT_SET(PORT_FND2);
	PORT_SET(PORT_FND3);

	if (di==0) PORT_CLR(PORT_FND0);
	else if (di==1) PORT_CLR(PORT_FND1);
	else if (di==2) PORT_CLR(PORT_FND2);
	else if (di==3) PORT_CLR(PORT_FND3);

	asm("sei");
}


//--------------------------------------------------------------------------
// tuning
//
void fnd_doDisplay()
{
	static int di = 0;

	// di = 0..3
	fnd_out(di, _fnd_data[di]);

	di = (di+1) % 4;
}
